struct Solution;

impl Solution {
    pub fn first_missing_positive(nums: Vec<i32>) -> i32 {
        let mut nums = nums;
        let n = nums.len();
        let mut has_one = false;
        for i in 0..n {
            if nums[i] == 1 {
                has_one = true;
            }
            if nums[i] <= 0 || nums[i] > n as i32 {
                nums[i] = 1;
            }
        }
        if !has_one {
            return 1;
        }

        for i in 0..n {
            let pos = nums[i].abs() as usize - 1;
            nums[pos] = -nums[pos].abs()
        }

        for i in 0..n {
            if nums[i] > 0 {
                return i as i32 + 1;
            }
        }
        n as i32 + 1
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_first_missing_positive() {
        assert_eq!(Solution::first_missing_positive(vec![1, 2, 0]), 3);
        assert_eq!(Solution::first_missing_positive(vec![3, 4, -1, 1]), 2);
        assert_eq!(Solution::first_missing_positive(vec![7, 8, 9, 11, 12]), 1);
        assert_eq!(Solution::first_missing_positive(vec![1, 2, 3]), 4);
        assert_eq!(Solution::first_missing_positive(vec![-1, -2, -3]), 1);
    }
}
