// leetcode 4. Median of Two Sorted Array

struct Solution;

const MAX: i32 = std::i32::MAX;

impl Solution {
    pub fn find_median_sorted_arrays(nums1: Vec<i32>, nums2: Vec<i32>) -> f64 {
        let total_len = nums1.len() + nums2.len();

        let median = total_len / 2;

        let (mut i, mut j) = (0, 0);

        let mut cur = 0;
        let mut last = 0;

        while i+j <= median {
            let a = nums1.get(i).or(Some(&MAX)).unwrap();
            let b = nums2.get(j).or(Some(&MAX)).unwrap();
            if a <= b {
                last = cur;
                cur = *a;
                i += 1;
            } else {
                last = cur;
                cur = *b;
                j += 1;
            }
        }

        if total_len % 2 == 0 {
            return (last + cur) as f64 / 2.0
        }

        return cur as f64

    }

}

#[cfg(test)]
mod tests {

    use super::*;

    #[test]
    fn test_find_median_sorted_arrays() {
        let a =  vec![vec![1,3]];
        let b =  vec![vec![2]];
        let res: Vec<f64> = a.iter().zip(b.iter()).map( |(a, b)| {
            Solution::find_median_sorted_arrays(a.clone(),b.clone())

        }).collect();

        assert_eq!(res, [2.0]);

    }
}
