struct Solution;

impl Solution {
    pub fn combination_sum2(candidates: Vec<i32>, target: i32) -> Vec<Vec<i32>> {
        let mut res = vec![];
        let mut cur = vec![];
        let mut candidates = candidates;
        candidates.sort();
        Self::bt(&candidates[..], target, &mut cur, &mut res);

        res
    }

    fn bt(candidates: &[i32], target: i32, cur: &mut Vec<i32>, res: &mut Vec<Vec<i32>>) {
        if target < 0 {
            return;
        }

        if target == 0 {
            res.push(cur.to_vec());
            return;
        }

        for (i, &n) in candidates.iter().enumerate() {
            if i > 0 && candidates[i] == candidates[i - 1] {
                continue;
            }
            cur.push(n);

            Self::bt(&candidates[i + 1..], target - n, cur, res);
            cur.pop();
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_combination_sum2_0() {
        assert_eq!(
            Solution::combination_sum2(vec![10, 1, 2, 7, 6, 1, 5], 8),
            vec![vec![1, 1, 6], vec![1, 2, 5], vec![1, 7], vec![2, 6]]
        );
    }

    #[test]
    fn test_combination_sum2_1() {
        assert_eq!(
            Solution::combination_sum2(vec![2, 5, 2, 1, 2], 5),
            vec![vec![1, 2, 2], vec![5]]
        );
    }
}
