struct Solution;

impl Solution {
    pub fn can_jump1(nums: Vec<i32>) -> bool {
        let n = nums.len();
        if n == 1 {
            return true;
        }

        let mut i = 0;
        while i < n {
            if i == n - 1 {
                return true;
            }

            if nums[i] == 0 {
                return false;
            }

            let mut max_idx = i;
            let start = i + 1;
            let end = (i + nums[i] as usize).min(n - 1);
            let mut next_i = i + 1;
            for j in start..=end {
                if max_idx < nums[j] as usize + j {
                    next_i = j;
                    max_idx = nums[j] as usize + j;
                }
            }
            if max_idx == i {
                return false;
            } else {
                i = next_i;
            }
        }
        true
    }

    pub fn can_jump(nums: Vec<i32>) -> bool {
        let n = nums.len();
        if n == 1 {
            return true;
        }

        Self::dfs(0, n, &nums)
    }

    fn dfs(idx: usize, n: usize, nums: &Vec<i32>) -> bool {
        if idx >= n - 1 {
            return true;
        }

        if nums[idx] == 0 {
            return false;
        }

        let start = idx + 1;
        let end = (idx + nums[idx] as usize).min(n - 1);
        let mut next_idx = start;
        let mut max_idx = start;
        for i in (start..=end).rev() {
            if nums[i] as usize + i > max_idx {
                next_idx = i;
                max_idx = nums[i] as usize + i;
            }
        }
        Self::dfs(next_idx, n, nums)
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case0() {
        let nums = vec![2, 3, 1, 1, 4];
        let res = Solution::can_jump1(nums);
        assert_eq!(res, true);
    }

    #[test]
    fn test_case1() {
        let nums = vec![2, 3, 1, 1, 4];
        let res = Solution::can_jump(nums);
        assert_eq!(res, true);
    }

    #[test]
    fn test_case2() {
        let nums = vec![3, 2, 1, 0, 4];
        let res = Solution::can_jump(nums);
        assert_eq!(res, false);
    }

    #[test]
    fn test_case3() {
        let nums = vec![0, 1];
        let res = Solution::can_jump(nums);
        assert_eq!(res, false);
    }

    #[test]
    fn test_case4() {
        let nums = vec![2, 0];
        let res = Solution::can_jump(nums);
        assert_eq!(res, true);
    }

    #[test]
    fn test_case5() {
        let nums = vec![5, 9, 3, 2, 1, 0, 2, 3, 3, 1, 0, 0];
        let res = Solution::can_jump(nums);
        assert_eq!(res, true);
    }
}
