struct Solution;

impl Solution {
    pub fn solve_n_queens(n: i32) -> Vec<Vec<String>> {
        let n = n as usize;
        let mut col_mask = vec![false; n];
        let mut mask = vec![vec![false; n]; n];

        let mut cur = vec![vec!['.'; n]; n];
        let mut res = vec![];

        Self::helper(0, n, &mut cur, &mut res, &mut col_mask, &mut mask);
        println!("{:?}", res);

        res
    }

    fn helper(
        i: usize,
        n: usize,
        cur: &mut Vec<Vec<char>>,
        res: &mut Vec<Vec<String>>,
        col_mask: &mut Vec<bool>,
        mask: &mut Vec<Vec<bool>>,
    ) {
        if i == n {
            let q: Vec<String> = cur.iter().map(|x| x.iter().collect::<String>()).collect();
            res.push(q);
            return;
        }

        for idx in 0..n {
            if col_mask[idx] {
                continue;
            }
            let mut r = i as i32;
            let mut c = idx as i32;
            let mut flag = false;
            r -= 1;
            c -= 1;
            while r >= 0 && c >= 0 {
                if mask[r as usize][c as usize] {
                    flag = true;
                    break;
                }
                r -= 1;
                c -= 1;
            }
            let mut r = i as i32;
            let mut c = idx as i32;
            r -= 1;
            c += 1;
            while r >= 0 && c < n as i32 {
                if mask[r as usize][c as usize] {
                    flag = true;
                    break;
                }

                r -= 1;
                c += 1;
            }
            if flag {
                continue;
            }

            cur[i][idx] = 'Q';
            col_mask[idx] = true;
            mask[i][idx] = true;

            Self::helper(i + 1, n, cur, res, col_mask, mask);

            cur[i][idx] = '.';
            col_mask[idx] = false;
            mask[i][idx] = false;
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_solve_n_queens() {
        let n = 4;
        let _res = Solution::solve_n_queens(n);
    }
}
