struct Solution;

impl Solution {
    pub fn subsets(nums: Vec<i32>) -> Vec<Vec<i32>> {
        let mut res = vec![];
        let mut cur = vec![];
        let n = nums.len();
        Solution::helper(&nums, n, 0, &mut cur, &mut res);
        res
    }

    fn helper(nums: &Vec<i32>, n: usize, idx: usize, cur: &mut Vec<i32>, res: &mut Vec<Vec<i32>>) {
        res.push(cur.clone());
        for i in idx..n {
            cur.push(nums[i]);
            Solution::helper(nums, n, i+1, cur, res);
            cur.pop();
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_subsets1() {
        let nums = vec![1,2,3];
        let res = Solution::subsets(nums);
        assert_eq!(res, vec![vec![],vec![1],vec![1,2],vec![1,2,3],vec![1,3],vec![2],vec![2,3],vec![3]]);
    }
}