struct Solution;

use std::collections::HashSet;

impl Solution {
    pub fn word_break(s: String, word_dict: Vec<String>) -> bool {
        let m: HashSet<String> = word_dict.into_iter().collect();

        Solution::helper(&s[..], &m, s.len(), 0, 1)

    }

    fn helper(s: &str, word_dict: &HashSet<String>, n: usize, begin: usize, end: usize) -> bool {
        if n == end {
            if word_dict.contains(&s[begin..end].to_string()) {
                return true;
            } else {
                return false;
            }
        }

        if word_dict.contains(&s[begin..end].to_string()) {
            if Solution::helper(s, word_dict, n, end, end + 1) {
                return true;
            } else {
                if Solution::helper(s, word_dict, n, begin, end + 1) {
                    return true;
                }
            }
        } else {
            if Solution::helper(s, word_dict, n, begin, end + 1) {
                return true
            }
        }

        false

    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_word_break() {
        let s = String::from("applepenapple");
        let word_dict = vec!["apple","pen"];
        let word_dict = word_dict.into_iter().map(|x| x.to_string()).collect::<Vec<String>>();
        let res = Solution::word_break(s, word_dict);

        assert_eq!(res, true);


    }

    #[test]
    fn test_word_break2() {
        let s = String::from("aaaaaaa");
        let word_dict = vec!["aaaa","aaa"];
        let word_dict = word_dict.into_iter().map(|x| x.to_string()).collect::<Vec<String>>();
        let res = Solution::word_break(s, word_dict);

        assert_eq!(res, true);


    }

}