struct Solution;

use std::collections::HashSet;
impl Solution {
    pub fn exist(board: Vec<Vec<char>>, word: String) -> bool {
        let m = board.len();
        let n = board[0].len();
        let word = word.chars().into_iter().collect::<Vec<char>>();
        let mut visited = HashSet::new();

        for i in 0..m {
            for j in 0..n {
                if word[0] != board[i][j] { continue; }
                if Solution::helper(&board, &word, m, n, (i as i32, j as i32), 0, &mut visited) {
                    return true;
                }
            }
        }

        false

    }

    fn helper(board: &Vec<Vec<char>>, word: &Vec<char>, m: usize, n: usize, point: (i32, i32), idx: usize, visited: &mut HashSet<(i32, i32)>) -> bool {
        let (i, j) = point;
        if i < 0 || j < 0 { return false; }
        if i >= m as i32 || j >= n as i32 { return false; }

        let (ii, jj) = (i as usize, j as usize);
        let cur_char = board[ii][jj];
        if cur_char != word[idx] {
            return false;
        }
        visited.insert(point);
        if word.len()-1 == idx {
            return true;
        }

        let  candidates = vec![(i+1, j), (i-1, j), (i, j+1), (i, j-1)];
        for c in candidates {
            if visited.contains(&c) {
                continue;
            }
            if Solution::helper(board, word, m, n, c, idx+1, visited) {
                return true;
            }
        }
        visited.remove(&point);



        false
    }
}


#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_exist1() {
        let board = vec![vec!['A','B','C','E'],vec!['S','F','C','S'],vec!['A','D','E','E']];
        let word = String::from("ABCCED");
        let res = Solution::exist(board, word);
        assert_eq!(res, true);
    }

    #[test]
    fn test_exist2() {
        let board = vec![vec!['A','B','C','E'],vec!['S','F','E','S'],vec!['A','D','E','E']];
        let word = String::from("ABCESEEEFS");
        let res = Solution::exist(board, word);
        assert_eq!(res, true);
    }
}