struct Solution;

impl Solution {
    pub fn max_area(height: Vec<i32>) -> i32 {
        let (mut i, mut j) = (0, height.len()-1);
        let mut res = 0;

        while i < j {
            let  cur_res = std::cmp::min(height[i], height[j]) * (j - i) as i32;
            if cur_res > res {
                res = cur_res;
            }
            let h = std::cmp::min(height[j], height[i]);
            while height[i] <= h && i < j {
                i += 1;
            }
            while height[j] <= h && j > i {
                j -= 1;
            }

        }

        res

    }

    pub fn max_area2(height: Vec<i32>) -> i32 {
        let mut max_left = 0;
        let mut max_right = 1;
        for i in 2..height.len() {
            if height[i] > height[max_left] || height[i] > height[max_right] {
                if height[max_left] <= height[max_right] {
                    max_left = i;
                } else {
                    max_right = i
                }
            }
        }


        let (i, mut j) = if max_left > max_right {
            (max_right, max_left)
        } else {
            (max_left, max_right)
        };

        let (mut max_left, mut max_right) = (i, j);
        let (max_left_1, max_right_1) = (i, j);

        println!("max_left: {}, max_right: {}, height: {}, {}", i, j, height[i], height[j]);

        let l = height.len();
        let mut res = std::cmp::min(height[max_right], height[max_left]) * (max_right - max_left) as i32;

        let mut i = i as i32;

        i -= 1;

        while i >=0  {
            let cur_res = std::cmp::min(height[max_right], height[i as usize]) * (max_right as i32 - i) ;
            res = if cur_res > res {
                max_left = i as usize;
                cur_res
            } else {
                res
            };
            i -= 1;
        }

        j += 1;

        while j < l  {
            let cur_res = std::cmp::min(height[j], height[max_left]) * (j - max_left) as i32;
            res = if cur_res > res {
                max_right = j;
                cur_res
            } else {
                res
            };
            j += 1;
        }

        println!("max_left: {}, max_right: {}, height: {}, {}",  max_left, max_right, height[max_left], height[max_right]);

        let (mut max_left, mut max_right) = (max_left_1, max_right_1);
        let (ii, jj) = (max_left_1, max_right_1+1);

        for i in 0..ii {
            for j in jj..l {
                let cur_res = std::cmp::min(height[j], height[i]) * (j - i) as i32;
                res = if cur_res > res {
                    max_right = j;
                    max_left = i;
                    cur_res
                } else {
                    res
                };

            }
        }
        println!("max_left: {}, max_right: {}, height: {}, {}",  max_left, max_right, height[max_left], height[max_right]);


        res

    }
}

#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_max_area() {
        assert_eq!(Solution::max_area(vec![8,10,14,0,13,10,9,9,11,11]), 80);
        assert_eq!(Solution::max_area2(vec![1,2]), 1);
        assert_eq!(Solution::max_area(vec![1,2,4,3]), 4);
    }
}