struct Solution;

impl Solution {
    pub fn max_profit(prices: Vec<i32>) -> i32 {
        let mut ans = 0;
        if prices.len() == 1 {
            return 0;
        }
        let mut min_price = prices[0];

        for i in 1..prices.len() {
            ans = (prices[i] - min_price).max(ans);
            min_price = min_price.min(prices[i]);
        }

        ans.max(0)
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case1() {
        let prices = vec![7, 1, 5, 3, 6, 4];
        let res = Solution::max_profit(prices);
        assert_eq!(res, 5);
    }

    #[test]
    fn test_case2() {
        let prices = vec![7, 6, 4, 3, 1];
        let res = Solution::max_profit(prices);
        assert_eq!(res, 0);
    }
}
