struct Solution;

impl Solution {
    pub fn candy(ratings: Vec<i32>) -> i32 {
        let l = ratings.len();
        let mut dp = vec![1; l];
        for i in 1..l {
            if ratings[i] > ratings[i-1] {
                dp[i] = dp[i-1] + 1;
            }
        }

        for i in (0..l-1).rev() {
            if ratings[i] > ratings[i+1] {
                dp[i] = dp[i].max(dp[i+1] + 1);
            }

        }

        dp.into_iter().sum()
    }
}


#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_candy() {
        let ratings = vec![1,0,2];
        let res = Solution::candy(ratings);
        assert_eq!(res, 5);
    }

    #[test]
    fn test_candy1() {
        let ratings = vec![1,3,2,2,1];
        let res = Solution::candy(ratings);
        assert_eq!(res, 7);
    }
}