struct Solution;

impl Solution {
    pub fn num_distinct(s: String, t: String) -> i32 {
        let vs = s.chars().into_iter().collect::<Vec<_>>();
        let vt = t.chars().into_iter().collect::<Vec<_>>();
        let nt = vt.len();
        let ns = vs.len();

        let mut dp = vec![vec![0; nt]; ns];

        for j in 0..nt {
            if j == 0 && vt[j] == vs[0] {
                dp[0][0] = 1;
            } else {
                break;
            }
        }

        for i in 1..ns {
            for j in 0..nt {
                if j == 0 {
                    if vs[i] == vt[j] {
                        dp[i][0] = dp[i-1][0] + 1;
                    } else {
                        dp[i][0] = dp[i-1][0];
                    }
                } else {
                    if vs[i] == vt[j] {
                        dp[i][j] = dp[i-1][j-1] + dp[i-1][j];
                    } else {
                        dp[i][j] = dp[i-1][j];
                    }
                }
            }
        }
        dp[ns-1][nt-1]

    }
}


#[cfg(test)]
mod tests {
    use super::*;


    #[test]
    fn test_num_distinct() {
        let s = String::from( "babgbag");
        let t = String::from("bag");
        let res = Solution::num_distinct(s, t);
        assert_eq!(res, 5);
    }

    #[test]
    fn test_num_distinct2() {
        let s = String::from( "rabbbit");
        let t = String::from("rabbit");
        let res = Solution::num_distinct(s, t);
        assert_eq!(res, 3);
    }

}