struct Solution;

impl Solution {
    pub fn edit_distance(s: String, p: String) -> usize {
        let i = s.len();
        let j = p.len();
        let sv = s.chars().collect::<Vec<char>>();
        let pv = p.chars().collect::<Vec<char>>();
        if i == 0 {
            return j;
        }
        if j == 0 {
            return i;
        }
        if i == 1 && j == 1 && sv[i - 1] == pv[j - 1] {
            return 0;
        }

        if sv[i - 1] == pv[j - 1] {
            return Solution::edit_distance(s[0..i - 1].into(), p[0..j - 1].into());
        }

        let v = vec![
            Solution::edit_distance(s[0..i - 1].into(), p[0..j - 1].into()),
            Solution::edit_distance(s[0..i - 1].into(), p[0..j].into()),
            Solution::edit_distance(s[0..i].into(), p[0..j - 1].into()),
        ];

        let min_value = v.iter().min().unwrap();
        return 1 + min_value;
    }

    pub fn edit_distance2(s: String, p: String) -> usize {
        let i = s.len();
        let j = p.len();
        if i == 0 {
            return j;
        }
        if j == 0 {
            return i;
        }
        let sv = s.chars().collect::<Vec<char>>();
        let pv = p.chars().collect::<Vec<char>>();

        let mut dp = vec![0; j + 1];
        for k in 0..=j {
            dp[k] = k
        }

        for m in 1..=i {
            println!("{:?}", dp);

            let mut nxt_k = 0;
            for n in 0..=j {
                if n == 0 {
                    nxt_k = m;
                    continue;
                }

                let tmp = nxt_k;
                if sv[m - 1] == pv[n - 1] {
                    nxt_k = dp[n - 1]
                } else {
                    let v = vec![tmp, dp[n - 1], dp[n]];
                    let min_value = v.iter().min().unwrap();
                    nxt_k = 1 + min_value;
                }
                dp[n - 1] = tmp;
                if n == j {
                    dp[n] = nxt_k;
                }
            }
        }
        return dp[j];
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn edit_distance_works() {
        let s = String::from("abbc");
        let p = String::from("acc");
        let result = Solution::edit_distance(s, p);
        let expect: usize = 2;
        assert_eq!(result, expect);

        let ss = String::from("aaabbb");
        let pp = String::from("abbb");
        let result = Solution::edit_distance(ss, pp);
        let expect: usize = 2;
        assert_eq!(result, expect);
    }
    #[test]
    fn edit_distance2_works() {
        let s = String::from("abbc");
        let p = String::from("acc");
        let result = Solution::edit_distance2(s, p);
        let expect: usize = 2;
        assert_eq!(result, expect);

        let ss = String::from("aaabbb");
        let pp = String::from("abbb");
        let result = Solution::edit_distance2(ss, pp);
        let expect: usize = 2;
        assert_eq!(result, expect);

        let sss = String::from("a");
        let ppp = String::from("");
        let result = Solution::edit_distance2(sss, ppp);
        let expect: usize = 1;
        assert_eq!(result, expect);
    }
}
