struct Solution;
impl Solution {
    pub fn longest_valid_parentheses(s: String) -> i32 {
        // dp[i]: longest valid parentheses that ends with s[i]
        // dp[i] = max(2 + dp[i-2] if s[i-1] == '(' and s[i] == ')',
        //             2 + dp[i-1] + dp[i - 1 - dp[i-1] - 1]
        //             if s[i - 1 - dp[i-1]] == '(' and s[i] == ')' and s[i-1] == ')'
        //            )
        let n = s.len();

        let s = s.into_bytes();
        let mut dp = vec![0; n];

        for i in 1..n {
            if s[i] == b'(' {
                continue;
            }

            if s[i - 1] == b'(' {
                dp[i] = 2 + {
                    if i >= 2 {
                        dp[i - 2]
                    } else {
                        0
                    }
                }
            } else if s.get(i - 1 - dp[i - 1] as usize) == Some(&b'(') {
                dp[i] = 2 + dp[i - 1] + dp.get(i - 1 - dp[i - 1] as usize - 1).unwrap_or(&0);
            }
        }

        dp.into_iter().max().unwrap_or(0)
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_longest_valid_parentheses() {
        assert_eq!(Solution::longest_valid_parentheses(String::from("(()")), 2);
        assert_eq!(
            Solution::longest_valid_parentheses(String::from(")()())")),
            4
        );
    }
}
