struct Solution;
use crate::solutions::ListNode;

impl Solution {
    pub fn delete_duplicates(head: Option<Box<ListNode>>) -> Option<Box<ListNode>> {

        match head {
            None => return None,
            Some(mut x) => {
                if let Some(y) = x.next {
                    if y.val == x.val {
                        x.next = y.next;
                        return Solution::delete_duplicates(Some(x));
                    } else {
                        x.next = Solution::delete_duplicates(Some(y));
                        return Some(x);

                    }
                }
                return Some(x)

            }
        }

    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{to_list, to_vec};

    #[test]
    fn test_delete_duplicates() {
        let head = to_list(vec![1,2,3,3,4,4,5]);
        let res = Solution::delete_duplicates(head);
        assert_eq!(to_vec(res), vec![1,2,3,4,5]);
    }


}