use crate::solutions::ListNode;

struct Solution;

impl Solution {
    pub fn rotate_right(head: Option<Box<ListNode>>, k: i32) -> Option<Box<ListNode>> {
        let mut head = match head{
            Some(a) => a,
            None => return None,

        };
        let len = Solution::list_len2(&head);

        let mut target = len - k as usize % len;

        if len == target {
            return Some(head);
        }

        let mut cur = &mut head;
        while target > 1 {
            cur = cur.next.as_mut().unwrap();
            target -= 1
        }


        let mut res = std::mem::replace(&mut cur.next, None).unwrap();
        let mut cur = &mut res;
        while let Some(ref mut next) = cur.next {
            cur = next;
        }
        cur.next = Some(head);
        Some(res)

    }

    fn list_len(head: Option<Box<ListNode>>) -> usize {
        let  mut dummy = Some(Box::new(ListNode {
            val: -1,
            next: head,
        }));

        let mut cur = &mut dummy;
        let mut l: usize = 0;
        while cur.as_ref().unwrap().next.is_some() {
            cur = &mut cur.as_mut().unwrap().next;
            l += 1;
        }
        l

    }
    
    fn list_len2(head: &Box<ListNode>) -> usize {
        let mut l: usize = 1;
        // let mut head = head;
        let mut cur = head;
        while let Some(ref next) = cur.next {
            cur = next;
            l+=1;

        }
        l
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{to_list, to_vec};

    #[test]
    fn test_list_len() {
        let v = vec![1,2,3,4];
        let head = to_list(v);
        let res = Solution::list_len(head);
        assert_eq!(4, res);
    }

    #[test]
    fn test_list_len2() {
        let v = vec![1,2,3,4];
        let head = to_list(v);
        let res = Solution::list_len2(&head.unwrap());
        assert_eq!(4, res);
    }

    #[test]
    fn test_rotate_right() {
        let v = vec![1,2,3,4];
        let head = to_list(v);
        let k = 1;
        let res = Solution::rotate_right(head, k);
        assert_eq!(to_vec(res), vec![4,1,2,3])

    }
}