use crate::solutions::ListNode;
struct Solution;
impl Solution {
    pub fn sort_list(head: Option<Box<ListNode>>) -> Option<Box<ListNode>> {
        let mut head = head;
        let mut v = vec![];

        while let Some(mut node) = head {
            head = node.next.take();
            v.push(node);
        }

        v.sort_by_key(|node| node.val);

        while !v.is_empty() {
            let mut node = v.pop().unwrap();
            node.next = head.take();
            head = Some(node);
        }

        head

    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{to_vec, to_list};

    #[test]
    fn test_sort_list() {
        let nums = vec![-1, 5, 3, 4, 0];
        let head = to_list(nums);
        let res = Solution::sort_list(head);
        assert_eq!(to_vec(res), vec![-1, 0, 3, 4, 5]);
    }
}