struct Solution;

impl Solution {
    pub fn length_of_longest_substring(s: String) -> i32 {
        if s.len() == 0 { return 0 }

        let mut i: usize = 0;
        let mut ans = 0;
        let mut m = std::collections::HashMap::<char, usize>::new();
        for (j, c) in s.char_indices() {

            m.entry(c).and_modify(|old_idx| {
                if *old_idx >= i {
                    ans = std::cmp::max(ans, j-i);
                    i = *old_idx + 1;
                }
                // 更新该字母的最后的idx
                *old_idx = j;
            }).or_insert(j);
        }

        std::cmp::max(ans, s.len()-i) as i32

    }

    pub fn length_of_longest_substring2(s: String) -> i32 {
        if s.len() == 0 { return 0 }

        let v = s.chars().into_iter().collect::<Vec<_>>();
        let mut cur_max: i32 = 0;
        let mut cur_prefix: Vec<char> = vec![];
        for i in 0..v.len() {
            if i == 0 {
                cur_max = 1;
                cur_prefix.push(v[i]);
                continue;
            }

            // 从后往前查找是否重复
            let l = cur_prefix.len();
            let mut repeat = false;

            for k in (0..l).rev() {
                if v[i] == cur_prefix[k] {
                    repeat = true;
                    cur_prefix.push(v[i]);
                    cur_prefix = cur_prefix[(k+1)..].to_vec();

                    break;
                }
            }

            if repeat == false {
                cur_prefix.push(v[i]);
            }

            cur_max = std::cmp::max(cur_max, cur_prefix.len() as i32);

        }

        cur_max

    }

}

#[cfg(test)]
mod tests {

    use super::*;

    #[test]
    fn test_case_1() {
        let s =  vec!["abcabcbb", "bbbbb", "pwwkew"];
        let res: Vec<i32> = s.iter().map(|&s| {
            Solution::length_of_longest_substring(s.into())

        }).collect();

        assert_eq!(res, [3,1,3]);

    }

     #[test]
    fn test_case_2() {
        let s =  vec!["abcabcbb", "bbbbb", "pwwkew"];
        let res: Vec<i32> = s.iter().map(|&s| {
            Solution::length_of_longest_substring2(s.into())

        }).collect();

        assert_eq!(res, [3,1,3]);

    }


}