struct Solution;

impl Solution {
    pub fn divide(dividend: i32, divisor: i32) -> i32 {
        let sign: i64 = match (dividend, divisor) {
            (x, y) if x < 0 && y < 0 => 1,
            (x, y) if x < 0 && y > 0 => -1,
            (x, y) if x > 0 && y < 0 => -1,
            (x, y) if x > 0 && y > 0 => 1,
            (x, _) if x == 0 => 0,
            _ => unreachable!(),
        };

        let dividend: i64 = (dividend as i64).abs();
        let divisor: i64 = (divisor as i64).abs();

        if (dividend / divisor * sign) > i32::MAX as i64 {
            return i32::MAX;
        } else {
            (dividend / divisor * sign) as i32
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_divide() {
        assert_eq!(Solution::divide(10, 3), 3);
        assert_eq!(Solution::divide(7, -3), -2);
        assert_eq!(Solution::divide(1, 1), 1);
        assert_eq!(Solution::divide(1, -1), -1);
        assert_eq!(Solution::divide(std::i32::MIN, -1), std::i32::MAX);
        assert_eq!(Solution::divide(std::i32::MIN, 1), std::i32::MIN);
        assert_eq!(Solution::divide(std::i32::MIN, std::i32::MIN), 1);
    }
}
