struct Solution;

impl Solution {
    pub fn merge(intervals: Vec<Vec<i32>>) -> Vec<Vec<i32>> {
        let mut intervals = intervals;
        let n = intervals.len();

        if n == 1 {
            return intervals;
        }

        intervals.sort_by(|a, b| (a[0]).cmp(&b[0]));
        let mut ans = vec![];
        let mut cur = vec![intervals[0][0], intervals[0][1]];
        for i in 1..n {
            let end = cur[1];
            let start = intervals[i][0];
            if end >= start {
                cur[0] = cur[0];
                cur[1] = intervals[i][1].max(cur[1]);
            } else {
                ans.push(cur.clone());
                cur[0] = intervals[i][0];
                cur[1] = intervals[i][1];
            }
        }
        ans.push(cur.clone());

        ans
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case1() {
        let intervals = vec![vec![1, 3], vec![2, 6], vec![8, 10], vec![15, 18]];
        let res = Solution::merge(intervals);
        assert_eq!(res, vec![[1, 6], [8, 10], [15, 18]]);
    }

    #[test]
    fn test_case2() {
        let intervals = vec![vec![1, 4], vec![2, 3]];
        let res = Solution::merge(intervals);
        assert_eq!(res, vec![[1, 4]])
    }
}
