struct Solution;

impl Solution {
    pub fn multiply(num1: String, num2: String) -> String {
        let mut res: Vec<char> = vec![];
        let n2 = num2.len();
        let n1 = num1.len();
        if n1 == 1 && num1 == "0" {
            return "0".to_string();
        }
        if n2 == 1 && num2 == "0" {
            return "0".to_string();
        }

        for (i, c) in num2.char_indices() {
            let tmp = Self::multiply_one(num1.as_str(), c, n2 - 1 - i);
            if i == 0 {
                for c in tmp {
                    res.push(c);
                }
            } else {
                res = Self::add(&tmp, &res);
            }
        }

        res.into_iter().collect()
    }

    fn add(num1: &Vec<char>, num2: &Vec<char>) -> Vec<char> {
        let mut res = vec![];
        let mut carry = 0;

        let n1 = num1.len();
        let n2 = num2.len();

        //     for _ in 0..(n1 - n2) {
        //         num2.push('0');
        //     }
        // } else {
        //     for _ in 0..(n2 - n1) {
        //         num1.push('0');
        //     }
        // }
        let (mut i, mut j) = (n1 as i32 - 1, n2 as i32 - 1);
        while i >= 0 || j >= 0 {
            let c1 = if i >= 0 { num1[i as usize] } else { '0' };
            let c2 = if j >= 0 { num2[j as usize] } else { '0' };
            let c = (c1 as usize - '0' as usize) + (c2 as usize - '0' as usize) + carry;
            let s = ((c % 10) as u8 + b'0') as char;
            res.push(s);
            carry = c / 10;
            i -= 1;
            j -= 1;
        }

        if carry > 0 {
            res.push((carry as u8 + b'0') as char);
        }

        res.reverse();
        res
    }

    fn multiply_one(num1: &str, c: char, pos: usize) -> Vec<char> {
        let c = c as usize - '0' as usize;
        let c = c as i32;
        // let mut res = String::new();
        let mut res = vec![];
        for _ in 0..pos {
            res.push('0')
        }
        let mut carry = 0;
        for (_, x) in num1.chars().rev().enumerate() {
            let x = (x as usize - '0' as usize) as i32;
            let n = c * x + carry;
            carry = n / 10;
            let n = ((n % 10) as u8 + b'0') as char;
            res.push(n);
        }
        if carry != 0 {
            res.push((carry as u8 + b'0') as char);
        }
        res.reverse();
        res
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_multiply() {
        assert_eq!(
            Solution::multiply("123".to_string(), "456".to_string()),
            "56088".to_string()
        );
    }

    #[test]
    fn test_multiply_1() {
        assert_eq!(
            Solution::multiply("0".to_string(), "0".to_string()),
            "0".to_string()
        );
    }

    #[test]
    fn test_multiply_one() {
        assert_eq!(Solution::multiply_one("0", '0', 0), vec!['0']);
    }

    #[test]
    fn test_multiply_one_1() {
        assert_eq!(Solution::multiply_one("3", '6', 1), vec!['1', '8', '0']);
    }

    #[test]
    fn test_add_1() {
        assert_eq!(Solution::add(&vec!['3'], &vec!['1', '2']), vec!['1', '5']);
    }

    #[test]
    fn test_add_2() {
        assert_eq!(Solution::add(&vec!['3'], &vec!['9']), vec!['1', '2']);
    }

    #[test]
    fn test_add_3() {
        assert_eq!(
            Solution::add(&vec!['4', '9', '2', '0', '0'], &vec!['6', '1', '5', '0']),
            vec!['5', '5', '3', '5', '0']
        );
    }
}
