struct Solution;

use crate::solutions::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn level_order(root: Option<Rc<RefCell<TreeNode>>>) -> Vec<Vec<i32>> {

        let mut res = vec![];
        Solution::helper(vec![root], &mut res);
        res

    }

    fn helper(v: Vec<Option<Rc<RefCell<TreeNode>>>>, res: &mut Vec<Vec<i32>>) {
        if v.is_empty() { return; }
        let mut cur = vec![];
        let mut next_v = vec![];
        for o in v {
            if let Some(n) = o {
                cur.push(n.borrow().val);
                next_v.push(n.borrow().left.clone());
                next_v.push(n.borrow().right.clone());
            }
        }
        if !cur.is_empty() {
            res.push(cur);

        }
        Solution::helper(next_v, res);
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{vec_to_tree};


    #[test]
    fn test_level_order() {
        let nums = vec![Some(3),Some(9),Some(20),None,None,Some(15),Some(7)];
        let root = vec_to_tree(nums);
        let res = Solution::level_order(root);
        assert_eq!(vec![vec![3],vec![9,20],vec![15,7]], res);

    }

    #[test]
    fn test_level_order2() {
        let root = None;
        let res = Solution::level_order(root);
        assert_eq!(Vec::<Vec<i32>>::new(), res);

    }
}