struct Solution;

use crate::solutions::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn build_tree(preorder: Vec<i32>, inorder: Vec<i32>) -> Option<Rc<RefCell<TreeNode>>> {
        Solution::helper(&preorder[..], &inorder[..])

    }

    fn helper(preorder: &[i32], inorder: &[i32]) -> Option<Rc<RefCell<TreeNode>>> {
        if preorder.is_empty() {
            return None;
        }

        let root_val = preorder[0];
        let mut root_idx = 0;
        if preorder.len() == 1 {
            return Some(Rc::new(RefCell::new(TreeNode::new(root_val))))
        }
        for (i, &v) in inorder.iter().enumerate() {
            if root_val == v {
                root_idx = i;
                break;
            }

        }

        let root = Rc::new(RefCell::new(TreeNode::new(root_val)));
        root.borrow_mut().left = Solution::helper(&preorder[1..root_idx+1], &inorder[0..root_idx]);
        root.borrow_mut().right = Solution::helper(&preorder[root_idx+1..], &inorder[root_idx+1..]);

        Some(root)


    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{inorder_traversal};

    #[test]
    fn test_build_tree() {
        let preorder = vec![3,9,20,15,7];
        let inorder = vec![9,3,15,20,7];

        let root = Solution::build_tree(preorder, inorder);
        let res = inorder_traversal(root);

        assert_eq!(res, vec![9,3,15,20,7])


    }
}