struct Solution;
use crate::solutions::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn build_tree(inorder: Vec<i32>, postorder: Vec<i32>) -> Option<Rc<RefCell<TreeNode>>> {
        Solution::helper(&inorder[..], &postorder[..])


    }

    fn helper(inorder: &[i32], postorder: &[i32]) -> Option<Rc<RefCell<TreeNode>>> {
        if inorder.is_empty() {
            return None;
        }
        let l = inorder.len();
        let root_val = postorder[l-1];
        if l == 1 {
            return Some(Rc::new(RefCell::new(TreeNode::new(root_val))))
        }

        let root_idx = inorder.iter().position(|&x| x == root_val).unwrap_or(l-1);

        let root = Rc::new(RefCell::new(TreeNode::new(root_val)));
        root.borrow_mut().left = Solution::helper(&inorder[0..root_idx], &postorder[0..root_idx] );
        root.borrow_mut().right = Solution::helper(&inorder[root_idx+1..],&postorder[root_idx..l-1], );

        Some(root)


    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{inorder_traversal};

    #[test]
    fn test_build_tree() {

        let inorder = vec![9,3,15,20,7];
        let postorder = vec![3,9,20,15,7];

        let root = Solution::build_tree(inorder, postorder);
        let res = inorder_traversal(root);

        assert_eq!(res, vec![9,3,15,20,7])


    }
}