struct Solution;

use crate::solutions::{TreeNode, ListNode};

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn sorted_list_to_bst(head: Option<Box<ListNode>>) -> Option<Rc<RefCell<TreeNode>>> {
        if head.is_none() {
            return None;
        }

        Solution::helper(head.as_ref(), None)
    }

    fn helper(head: Option<&Box<ListNode>>, tail: Option<&Box<ListNode>>) -> Option<Rc<RefCell<TreeNode>>> {
        if head == tail {
            return None;
        }

        let mut slow = head;
        let mut fast = head;

        while fast != tail {
            let next_fast = fast.and_then(|n| n.next.as_ref());
            if next_fast == tail {
                break;
            }

            slow = slow.and_then(|n| n.next.as_ref());
            fast = next_fast.and_then(|n| n.next.as_ref());
        }


        let mut tree_node = TreeNode::new(slow.unwrap().val);
        tree_node.left = Solution::helper(head, slow);
        tree_node.right = Solution::helper(slow.unwrap().next.as_ref(), tail);

        Some(Rc::new(RefCell::new(tree_node)))
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{to_list, inorder_traversal};

    #[test]
    fn test_sorted_list_to_bst() {
        let nums = vec![-10,-3,0,5,9];
        let head = to_list(nums);
        let root = Solution::sorted_list_to_bst(head);
        let res = inorder_traversal(root);
        assert_eq!(res, vec![-10, -3, 0, 5, 9]);

    }
}