use crate::solutions::TreeNode;

struct Solution;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn inorder_traversal(root: Option<Rc<RefCell<TreeNode>>>) -> Vec<i32> {
        let mut res = vec![];
        Solution::traversal(root, &mut res);
        res

    }
    fn traversal(root: Option<Rc<RefCell<TreeNode>>>, res: &mut Vec<i32>) {
        if let Some(node) = root {
            Solution::traversal(node.borrow().left.clone(), res);
            res.push(node.borrow().val);
            Solution::traversal(node.borrow().right.clone(), res);
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{vec_to_tree};

    #[test]
    fn test_inorder_traversal() {
        let nums = vec![Some(1),Some(2),Some(3),Some(4),Some(5)];
        let root = vec_to_tree(nums);
        let res = Solution::inorder_traversal(root);
        assert_eq!(res, vec![4,2,5,1,3]);

    }
}