struct Solution;

use std::rc::Rc;
use std::cell::RefCell;

use crate::solutions::TreeNode;

impl Solution {
    pub fn is_same_tree(p: Option<Rc<RefCell<TreeNode>>>, q: Option<Rc<RefCell<TreeNode>>>) -> bool {
        match (p, q) {
            (None, None) => { return true; },
            (Some(n1), Some(n2)) => {
                if n1.borrow().val == n2.borrow().val {

                    return Solution::is_same_tree(n1.borrow().left.clone(), n2.borrow().left.clone()) && Solution::is_same_tree(n1.borrow().right.clone(), n2.borrow().right.clone())
                }
                return false;

            },
            (_, _) => {
                return false;
            }
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::vec_to_tree;

    #[test]
    fn test_is_same_tree() {
        let v1 = vec![Some(1), Some(2), Some(3)];
        let v2 = vec![Some(1), Some(2), Some(3)];
        let root1 = vec_to_tree(v1);
        let root2 = vec_to_tree(v2);
        assert_eq!(Solution::is_same_tree(root1, root2), true);
    }

    #[test]
    fn test_is_same_tree2() {
        let v1 = vec![Some(1), Some(2)];
        let v2 = vec![Some(1), None,  Some(2)];
        let root1 = vec_to_tree(v1);
        let root2 = vec_to_tree(v2);
        assert_eq!(Solution::is_same_tree(root1, root2), false);
    }

}