struct Solution;
use crate::solutions::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn is_symmetric(root: Option<Rc<RefCell<TreeNode>>>) -> bool {
        if let Some(n) = root {
            return Solution::helper(n.borrow().left.clone(), n.borrow().right.clone());
        }

        true
    }

    fn helper(p: Option<Rc<RefCell<TreeNode>>>, q: Option<Rc<RefCell<TreeNode>>>) -> bool {
        match (p, q) {
            (Some(n1), Some(n2)) => {
                return n1.borrow().val == n2.borrow().val && Solution::helper(n1.borrow().left.clone(), n2.borrow().right.clone())  && Solution::helper(n1.borrow().right.clone(), n2.borrow().left.clone());
            },
            (None, None) => {
                return true;
            },
            (_, _) => {
                return false;
            }
        }
    }
}


#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{vec_to_tree};


    #[test]
    fn test_is_symmetric() {
        let v = vec![Some(1),Some(2),Some(2),Some(3),Some(4),Some(4),Some(3)];
        let root = vec_to_tree(v);
        let res = Solution::is_symmetric(root);
        assert_eq!(res, true);
    }

    #[test]
    fn test_is_symmetric1() {
        let v = vec![Some(1),Some(2),Some(2),None,Some(3),None,Some(3)];
        let root = vec_to_tree(v);
        let res = Solution::is_symmetric(root);
        assert_eq!(res, false);
    }

}

